#ifndef RUFEOL_H
#define RUFEOL_H

#ifdef __BORLANDC__
#pragma warn -8004
#endif

#define VERSION 1.03
#define BLOCK_SIZE 2560
#define BUFFER_SIZE 104857600 /* 100 MB */
#define END_OF_FILE 2
#define ERROR_TEXT "error.txt"
#define FILE_ERROR -1L
#define FILE_ERROR_CODE -2
#define FILE_NAME_SIZE 255
#define FULL_LEVEL 1
#define RUFEOL_TEXT "draft.txt"
#define TAIL_LENGTH 1
#define TEMPORARY_BINARY "binary.tmp"
#include "integer_Q.h"
#include "numbered.h"

typedef struct REMOVE_FROM_LINE REMOVE_FROM_LINE;
struct REMOVE_FROM_LINE {
    BOOL no_removing;
    char *buffer;
    char *combo;
    int buffer_size, full_level, ring_count, unnecessary;
    long whole;
    char file_name[ FILE_NAME_SIZE + 1 ];
    char new_name[ FILE_NAME_SIZE + 1 ];
};

typedef int (*NEW_LINE_FUNCTION)(REMOVE_FROM_LINE *r, int k);

BOOL buffer_begins_with_bell(char *p);
BOOL setting(REMOVE_FROM_LINE *r, char *e, char *n, int b, int f, int u, BOOL g);
int insert_CRLF(REMOVE_FROM_LINE *r);
int insert_LF(REMOVE_FROM_LINE *r);
int rename_binary_file(const char *name, BOOL no_removing);
long file_size(char *file_name);
void error_handler(const char *p, char *q);
void prepare_ring(void);
void release(REMOVE_FROM_LINE *);
void version_guide(double v, BOOL comments);

#endif /* RUFEOL_H */
